diff --git a/base/deploy/src/scriptlets/infrastructure_layout.py b/base/deploy/src/scriptlets/infrastructure_layout.py
index d5ce233..4baada9 100644
--- a/base/deploy/src/scriptlets/infrastructure_layout.py
+++ b/base/deploy/src/scriptlets/infrastructure_layout.py
@@ -34,8 +34,39 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     def spawn(self):
         config.pki_log.info(log.ADMIN_DOMAIN_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        # establish top-level infrastructure base
+        # NOTE:  It was determined that since the "pkidestroy" command
+        #        relies upon a symbolic link to a replica of the original
+        #        "pkideployment.cfg" configuration file used by the
+        #        "pkispawn" command of an instance, it is necessary to
+        #        create any required instance and subsystem directories
+        #        in this top-level "infrastructure_layout" scriptlet
+        #        (rather than the "instance_layout" and "subsystem_layout"
+        #        scriptlets) so that a copy of this configuration file can
+        #        be saved, and the required symbolic link can be created.
+        #
+        # establish the top-level infrastructure, instance, and subsystem
+        # registry directories for storage of a copy of the original
+        # "pkideployment.cfg" configuration file used to spawn this instance,
+        # and save a copy of this file
+        util.directory.create(master['pki_registry_path'])
+        util.directory.create(master['pki_instance_type_registry_path'])
+        util.directory.create(master['pki_instance_registry_path'])
+        util.directory.create(master['pki_subsystem_registry_path'])
+        util.file.copy(master['pki_deployment_cfg'],
+                       master['pki_deployment_cfg_replica'])
+        # establish top-level infrastructure, instance, and subsystem
+        # base directories and create the "registry" symbolic link that
+        # the "pkidestroy" executable relies upon
         util.directory.create(master['pki_path'])
+        util.directory.create(master['pki_instance_path'])
+        util.directory.create(master['pki_subsystem_path'])
+        util.symlink.create(master['pki_instance_registry_path'],
+                            master['pki_subsystem_registry_link'])
+        #
+        # NOTE:  If "infrastructure_layout" scriptlet execution has been
+        #        successfully executed to this point, the "pkidestroy" command
+        #        may always be utilized to remove the entire infrastructure.
+        #
         # no need to establish top-level infrastructure logs
         # since it now stores 'pkispawn'/'pkidestroy' logs
         # and will already exist
@@ -44,8 +75,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         if master['pki_configuration_path'] !=\
            config.PKI_DEPLOYMENT_CONFIGURATION_ROOT:
             util.directory.create(master['pki_configuration_path'])
-        # establish top-level infrastructure registry
-        util.directory.create(master['pki_registry_path'])
         return self.rv
 
     def respawn(self):
@@ -82,10 +111,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     util.directory.delete(master['pki_configuration_path'])
                 # remove top-level infrastructure registry
                 util.directory.delete(master['pki_registry_path'])
-                if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-                    util.file.delete(
-                        master['pki_target_tomcat_conf_instance_id'])
-
         else:
             # ALWAYS display correct information (even during dry_run)
             if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
@@ -102,7 +127,4 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     util.directory.delete(master['pki_configuration_path'])
                 # remove top-level infrastructure registry
                 util.directory.delete(master['pki_registry_path'])
-                if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-                    util.file.delete(
-                        master['pki_target_tomcat_conf_instance_id'])
         return self.rv
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/deploy/src/scriptlets/initialization.py
index da1a934..f158592 100644
--- a/base/deploy/src/scriptlets/initialization.py
+++ b/base/deploy/src/scriptlets/initialization.py
@@ -32,8 +32,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
     def spawn(self):
-        # detect and avoid any namespace collisions
-        util.namespace.collision_detection()
         # begin official logging
         config.pki_log.info(log.PKISPAWN_BEGIN_MESSAGE_2,
                             master['pki_subsystem'],
@@ -41,6 +39,11 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" does NOT yet
+        # exist for this "instance"
+        util.instance.verify_subsystem_does_not_exist()
+        # detect and avoid any namespace collisions
+        util.namespace.collision_detection()
         # initialize 'uid' and 'gid'
         util.identity.add_uid_and_gid(master['pki_user'], master['pki_group'])
         # establish 'uid' and 'gid'
@@ -50,6 +53,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         util.configuration_file.verify_sensitive_data()
         # verify existence of MUTUALLY EXCLUSIVE configuration file data
         util.configuration_file.verify_mutually_exclusive_data()
+        # verify existence of PREDEFINED configuration file data
+        util.configuration_file.verify_predefined_configuration_file_data()
         # verify selinux context of selected ports
         util.configuration_file.populate_non_default_ports()
         util.configuration_file.verify_selinux_ports()
@@ -63,6 +68,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_RESPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" currently EXISTS
+        # for this "instance"
+        util.instance.verify_subsystem_exists()
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
@@ -76,6 +84,12 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" currently EXISTS
+        # for this "instance"
+        util.instance.verify_subsystem_exists()
+        # verify that the command-line parameters match the values
+        # that are present in the corresponding configuration file
+        util.configuration_file.verify_command_matches_configuration_file()
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 7829e24..013a960 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -34,15 +34,10 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     def spawn(self):
         config.pki_log.info(log.INSTANCE_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        # establish instance base
-        util.directory.create(master['pki_instance_path'])
         # establish instance logs
         util.directory.create(master['pki_instance_log_path'])
         # establish instance configuration
         util.directory.create(master['pki_instance_configuration_path'])
-        # establish instance registry
-        util.directory.create(master['pki_instance_type_registry_path'])
-        util.directory.create(master['pki_instance_registry_path'])
         # establish Apache/Tomcat specific instance
         if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # establish Tomcat instance base
@@ -256,6 +251,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 util.directory.delete(master['pki_instance_configuration_path'])
                 # remove Tomcat instance registry
                 util.directory.delete(master['pki_instance_type_registry_path'])
+                # remove PKI 'tomcat.conf' instance file
+                util.file.delete(master['pki_target_tomcat_conf_instance_id'])
         else:
             # ALWAYS display correct information (even during dry_run)
             if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
@@ -283,4 +280,6 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 util.directory.delete(master['pki_instance_configuration_path'])
                 # remove Tomcat instance registry
                 util.directory.delete(master['pki_instance_type_registry_path'])
+                # remove PKI 'tomcat.conf' instance file
+                util.file.delete(master['pki_target_tomcat_conf_instance_id'])
         return self.rv
diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index 6418322..47ed16f 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -107,28 +107,25 @@ pki_install_time = None
 pki_timestamp = None
 pki_architecture = None
 pki_hostname = None
-pki_pin = None
-pki_client_pin = None
-pki_one_time_pin = None
 
 
+# PKI Deployment Command-Line Variables
+pki_deployment_executable = None
+
 # PKI Deployment "Mandatory" Command-Line Variables
 pki_subsystem = None
 #     'pkispawn' ONLY
-pkideployment_cfg = "/usr/share/pki/deployment/config/pkideployment.cfg"
+pkideployment_cfg = None
+#     'pkidestroy' ONLY
+pki_deployed_instance_name = None
 
 # PKI Deployment "Optional" Command-Line Variables
 pki_dry_run_flag = False
-pki_root_prefix = None
+#     'pkispawn' ONLY
 pki_update_flag = False
 
-# PKI Deployment "Custom" Command-Line Variables
-custom_pki_admin_domain_name = None
-custom_pki_instance_name = None
-#     'pkispawn' ONLY
-custom_pki_http_port = None
-custom_pki_https_port = None
-custom_pki_ajp_port = None
+# PKI Deployment "Test" Command-Line Variables
+pki_root_prefix = None
 
 
 # PKI Deployment Helper Functions
diff --git a/base/deploy/src/scriptlets/pkihelper.py b/base/deploy/src/scriptlets/pkihelper.py
index 31877bf..c172301 100644
--- a/base/deploy/src/scriptlets/pkihelper.py
+++ b/base/deploy/src/scriptlets/pkihelper.py
@@ -421,8 +421,9 @@ class configuration_file:
             if not sensitive.has_key('pki_ds_password') or\
                not len(sensitive['pki_ds_password']):
                 config.pki_log.error(
-                    log.PKIHELPER_UNDEFINED_DS_PASSWORD_1,
-                    config.pkideployment_cfg,
+                    log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                    "pki_ds_password",
+                    master['pki_deployment_cfg'],
                     extra=config.PKI_INDENTATION_LEVEL_2)
                 sys.exit(1)
             # Verify existence of Admin Password (except for Clones)
@@ -430,8 +431,9 @@ class configuration_file:
                 if not sensitive.has_key('pki_admin_password') or\
                    not len(sensitive['pki_admin_password']):
                     config.pki_log.error(
-                        log.PKIHELPER_UNDEFINED_ADMIN_PASSWORD_1,
-                        config.pkideployment_cfg,
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_admin_password",
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
             # If required, verify existence of Backup Password
@@ -439,16 +441,27 @@ class configuration_file:
                 if not sensitive.has_key('pki_backup_password') or\
                    not len(sensitive['pki_backup_password']):
                     config.pki_log.error(
-                        log.PKIHELPER_UNDEFINED_BACKUP_PASSWORD_1,
-                        config.pkideployment_cfg,
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_backup_password",
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
+            # Verify existence of Client Pin for NSS client security databases
+            if not sensitive.has_key('pki_client_database_password') or\
+               not len(sensitive['pki_client_database_password']):
+                config.pki_log.error(
+                    log.PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2,
+                    "pki_client_database_password",
+                    master['pki_deployment_cfg'],
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
             # Verify existence of Client PKCS #12 Password for Admin Cert
             if not sensitive.has_key('pki_client_pkcs12_password') or\
                not len(sensitive['pki_client_pkcs12_password']):
                 config.pki_log.error(
-                    log.PKIHELPER_UNDEFINED_CLIENT_PKCS12_PASSWORD_1,
-                    config.pkideployment_cfg,
+                    log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                    "pki_client_pkcs12_password",
+                    master['pki_deployment_cfg'],
                     extra=config.PKI_INDENTATION_LEVEL_2)
                 sys.exit(1)
             # Verify existence of PKCS #12 Password (ONLY for Clones)
@@ -456,8 +469,9 @@ class configuration_file:
                 if not sensitive.has_key('pki_clone_pkcs12_password') or\
                    not len(sensitive['pki_clone_pkcs12_password']):
                     config.pki_log.error(
-                        log.PKIHELPER_UNDEFINED_CLONE_PKCS12_PASSWORD_1,
-                        config.pkideployment_cfg,
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_clone_pkcs12_password",
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
             # Verify existence of Security Domain Password File
@@ -468,8 +482,19 @@ class configuration_file:
                 if not sensitive.has_key('pki_security_domain_password') or\
                    not len(sensitive['pki_security_domain_password']):
                     config.pki_log.error(
-                        log.PKIHELPER_UNDEFINED_SECURITY_DOMAIN_PASSWORD_1,
-                        config.pkideployment_cfg,
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_security_domain_password",
+                        master['pki_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+            # If required, verify existence of Token Password
+            if not master['pki_token_name'] == "internal":
+                if not sensitive.has_key('pki_token_password') or\
+                   not len(sensitive['pki_token_password']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_token_password",
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
         return
@@ -483,31 +508,132 @@ class configuration_file:
                    config.str2bool(master['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA,
-                        config.pkideployment_cfg,
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
                 elif config.str2bool(master['pki_clone']) and\
                      config.str2bool(master['pki_external']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA,
-                        config.pkideployment_cfg,
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
                 elif config.str2bool(master['pki_clone']) and\
                      config.str2bool(master['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA,
-                        config.pkideployment_cfg,
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
                 elif config.str2bool(master['pki_external']) and\
                      config.str2bool(master['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA,
-                        config.pkideployment_cfg,
+                        master['pki_deployment_cfg'],
                         extra=config.PKI_INDENTATION_LEVEL_2)
                     sys.exit(1)
 
+    def verify_predefined_configuration_file_data(self):
+        # Silently verify the existence of any required 'predefined' data
+        #
+        # FUTURE:  As much as is possible, alter this routine to verify
+        #          ALL name/value pairs for the requested configuration
+        #          scenario.  This should include checking for the
+        #          "existence" of ALL required "name" parameters, as well as
+        #          the "existence", "type", and "correctness" of ALL required
+        #          "value" parameters.
+        #
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            if config.str2bool(config.pki_master_dict['pki_clone']):
+                # Verify existence of clone parameters
+                if not master.has_key('pki_clone_pkcs12_path') or\
+                   not len(master['pki_clone_pkcs12_path']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_clone_pkcs12_path",
+                        master['pki_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                elif not os.path.isfile(master['pki_clone_pkcs12_path']):
+                    config.pki_log.error(
+                        log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1,
+                        master['pki_clone_pkcs12_path'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not master.has_key('pki_clone_replication_security') or\
+                   not len(master['pki_clone_replication_security']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_clone_replication_security",
+                        master['pki_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not master.has_key('pki_clone_uri') or\
+                   not len(master['pki_clone_uri']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_clone_uri",
+                        master['pki_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+            elif master['pki_subsystem'] == "CA" and\
+                 config.str2bool(config.pki_master_dict['pki_external']):
+                if not master.has_key('pki_external_step_two') or\
+                   not len(master['pki_external_step_two']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_external_step_two",
+                        master['pki_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not config.str2bool(config.pki_master_dict['pki_step_two']):
+                    if not master.has_key('pki_external_csr_path') or\
+                       not len(master['pki_external_csr_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_csr_path",
+                            master['pki_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                    elif not os.path.isfile(master['pki_external_csr_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1,
+                            master['pki_external_csr_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                else:
+                    if not master.has_key('pki_external_ca_cert_chain_path') or\
+                       not len(master['pki_external_ca_cert_chain_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_ca_cert_chain_path",
+                            master['pki_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                    elif not os.path.isfile(
+                                 master['pki_external_ca_cert_chain_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1,
+                            master['pki_external_ca_cert_chain_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                    if not master.has_key('pki_external_ca_cert_path') or\
+                       not len(master['pki_external_ca_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_ca_cert_path",
+                            master['pki_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                    elif not os.path.isfile(
+                                 master['pki_external_ca_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1,
+                            master['pki_external_ca_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+        return
+
     def populate_non_default_ports(self):
         if master['pki_http_port'] != \
             config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_HTTP_PORT:
@@ -557,6 +683,20 @@ class configuration_file:
                 sys.exit(1)
         return
 
+    def verify_command_matches_configuration_file(self):
+        # Silently verify that the command-line parameters match the values
+        # that are present in the corresponding configuration file
+        if master['pki_deployment_executable'] == 'pkidestroy':
+            if master['pki_deployed_instance_name'] !=\
+               master['pki_instance_id']:
+                config.pki_log.error(
+                    log.PKIHELPER_COMMAND_LINE_PARAMETER_MISMATCH_2,
+                    master['pki_deployed_instance_name'],
+                    master['pki_instance_id'],
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+        return
+
 
 
 # PKI Deployment XML File Class
@@ -677,6 +817,32 @@ class instance:
             sys.exit(1)
         return rv
 
+    def verify_subsystem_exists(self):
+        try:
+            if not os.path.exists(master['pki_subsystem_path']):
+                config.pki_log.error(log.PKI_SUBSYSTEM_DOES_NOT_EXIST_2,
+                                     master['pki_subsystem'],
+                                     master['pki_instance_id'],
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
+    def verify_subsystem_does_not_exist(self):
+        try:
+            if os.path.exists(master['pki_subsystem_path']):
+                config.pki_log.error(log.PKI_SUBSYSTEM_ALREADY_EXISTS_2,
+                                     master['pki_subsystem'],
+                                     master['pki_instance_id'],
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
 
 # PKI Deployment Directory Class
 class directory:
@@ -792,10 +958,10 @@ class directory:
     def delete(self, name, recursive_flag=True, critical_failure=True):
         try:
             if not os.path.exists(name) or not os.path.isdir(name):
-                config.pki_log.error(
+                # Simply issue a warning and continue
+                config.pki_log.warning(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
                     extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
             else:
                 if recursive_flag == True:
                     # rm -rf <name>
@@ -816,6 +982,17 @@ class directory:
                 sys.exit(1)
         return
 
+    def exists(self, name):
+        try:
+            if not os.path.exists(name) or not os.path.isdir(name):
+                return False
+            else:
+                return True
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
     def is_empty(self, name):
         try:
             if not os.listdir(name):
@@ -1165,10 +1342,10 @@ class file:
     def delete(self, name, critical_failure=True):
         try:
             if not os.path.exists(name) or not os.path.isfile(name):
-                config.pki_log.error(
+                # Simply issue a warning and continue
+                config.pki_log.warning(
                     log.PKI_FILE_MISSING_OR_NOT_A_FILE_1, name,
                     extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
             else:
                 # rm -f <name>
                 config.pki_log.info(log.PKIHELPER_RM_F_1, name,
@@ -1182,6 +1359,17 @@ class file:
                 sys.exit(1)
         return
 
+    def exists(self, name):
+        try:
+            if not os.path.exists(name) or not os.path.isfile(name):
+                return False
+            else:
+                return True
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
     def copy(self, old_name, new_name, uid=None, gid=None,
              perms=config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS, acls=None,
              overwrite_flag=False, critical_failure=True):
@@ -1601,10 +1789,10 @@ class symlink:
     def delete(self, link, critical_failure=True):
         try:
             if not os.path.exists(link) or not os.path.islink(link):
-                config.pki_log.error(
+                # Simply issue a warning and continue
+                config.pki_log.warning(
                     log.PKI_SYMLINK_MISSING_OR_NOT_A_SYMLINK_1, link,
                     extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
             else:
                 # rm -f <link>
                 config.pki_log.info(log.PKIHELPER_RM_F_1, link,
@@ -1618,6 +1806,17 @@ class symlink:
                 sys.exit(1)
         return
 
+    def exists(self, name):
+        try:
+            if not os.path.exists(name) or not os.path.islink(name):
+                return False
+            else:
+                return True
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
 
 # PKI Deployment War File Class
 class war:
@@ -2149,6 +2348,7 @@ class jython:
             property = ""
             # Compose this "jython" command
             data = pickle.dumps(master)
+            sensitive_data = pickle.dumps(sensitive)
             ld_library_path = "LD_LIBRARY_PATH"
             if master['pki_architecture'] == 64:
                 ld_library_path = ld_library_path + "=" +\
@@ -2158,7 +2358,8 @@ class jython:
                 ld_library_path = ld_library_path + "=" +\
                                   "/usr/lib/jss:/usr/lib:/lib"
             command = "export" + " " + ld_library_path + ";" + "jython" + " " +\
-                      property + " " + scriptlet + " " + "\"" + data + "\""
+                      property + " " + scriptlet + " " + "\"" + data + "\"" +\
+                      " " + "\"" + sensitive_data + "\""
             # Display this "jython" command
             config.pki_log.info(
                 log.PKIHELPER_INVOKE_JYTHON_3,
